%define with_jansi 1
Name:           groovy18
Version:        1.8.5
Release:        %mkrel 1
Summary:        Dynamic language for the Java Platform

Group:          Development/Java 
License:        ASL 2.0
URL:            http://groovy.codehaus.org/
Source0:        http://dist.groovy.codehaus.org/distributions/groovy-src-%{version}.zip
Source1:        groovy18-script
Source2:        groovy18-starter.conf
Source3:        groovy18.desktop
Patch1:         groovy-1.8.1-nojansi.patch
# remove unavailable deps
#   org.codehaus.gpars gpars 0.11 https://github.com/GPars
# change version for 
#   junit 4.10
#   xstream 1.4.1
#   jansi 1.7
Patch2:         groovy-1.8.3-pom.patch
Patch3:         groovy-1.8.3-antbuild.patch
Patch4:         groovy-1.8.3-skipOsgi.patch

BuildArch:      noarch

BuildRequires:  ant
BuildRequires:  antlr
BuildRequires:  ant-antlr
BuildRequires:  ant-junit
#BuildRequires:  ant-testutil
BuildRequires:  objectweb-asm
BuildRequires:  bsf
BuildRequires:  apache-ivy

BuildRequires:  jline
BuildRequires:  jsp21
BuildRequires:  junit
BuildRequires:  servlet25
BuildRequires:  xstream
BuildRequires:  java-devel >= 1.6
BuildRequires:  desktop-file-utils
BuildRequires:  jpackage-utils
BuildRequires:  apache-commons-cli

BuildRequires:  aqute-bndlib
BuildRequires:  apache-commons-beanutils
BuildRequires:  apache-commons-lang
BuildRequires:  apache-commons-logging
%if %with_jansi
BuildRequires:  jansi
%endif
BuildRequires:  livetribe-jsr223
BuildRequires:  mockobjects
BuildRequires:  qdox
BuildRequires:  jarjar

BuildRequires:  unzip
Requires:       jpackage-utils

# The are all runtime dependencies of the script
# TODO: Think of splitting them into a separate subpackage
Requires:       ant
Requires:       ant-antlr
Requires:       ant-junit
Requires:       antlr-tool
Requires:       objectweb-asm
Requires:       bsf
Requires:       apache-commons-cli
Requires:       apache-commons-logging
Requires:       apache-ivy
Requires:       jline
Requires:       jsp21
Requires:       junit
Requires:       servlet25
Requires:       xstream
%if %with_jansi
Requires:       jansi
%endif
Requires:       jarjar
Requires:       livetribe-jsr223
Requires:       mockobjects
Requires:       qdox


%description
Groovy is an agile and dynamic language for the Java Virtual Machine,
built upon Java with features inspired by languages like Python, Ruby and
Smalltalk.  It seamlessly integrates with all existing Java objects and
libraries and compiles straight to Java bytecode so you can use it anywhere
you can use Java.


%package javadoc
Summary:        API Documentation for %{name}
Group:          Development/Java 
Requires:       %{name} = %{version}-%{release}
Requires:       jpackage-utils

%description javadoc
JavaDoc documentation for %{name}

%prep
%setup -q -n groovy-%{version}

#%if !%with_jansi
#%patch1 -p1 -b .jansi
#%endif
%patch2 -p0
%patch3 -p1
%patch4 -p0

%build

mkdir -p target/lib/{compile,runtime,tools}
# Construct classpath 
export CLASSPATH=""
%if %with_jansi
CLASSPATH=$CLASSPATH:$(build-classpath jansi)
%endif
CLASSPATH=$CLASSPATH:$(build-classpath antlr ant ant/ant-junit ant/ant-antlr ant-launcher servlet jsp bsf)
CLASSPATH=$CLASSPATH:$(build-classpath commons-cli mockobjects-core qdox jarjar livetribe-jsr223 junit)
CLASSPATH=$CLASSPATH:$(build-classpath log4j aqute-bndlib objectweb-asm commons-beanutils commons-beanutils-core)
CLASSPATH=$CLASSPATH:$(build-classpath commons-lang commons-logging oro jline xstream ivy)

# Build
# TODO: Build at least tests, maybe examples
ant -DskipTests=on -DskipExamples=on -DskipFetch=on \
        createJars javadoc

%install

# Code
install -d $RPM_BUILD_ROOT%{_javadir}
install -p -m644 target/dist/groovy.jar $RPM_BUILD_ROOT%{_javadir}/%{name}.jar
install -p -m644 target/dist/groovy-all.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-all.jar
# Startup scripts
install -d $RPM_BUILD_ROOT%{_bindir}
install -p -m755 %{SOURCE1} $RPM_BUILD_ROOT%{_bindir}/groovy18
%if %with_jansi
sed -i 's|#BASE_JARS="$BASE_JARS jansi"|BASE_JARS="$BASE_JARS jansi"|' $RPM_BUILD_ROOT%{_bindir}/groovy18
%endif
for TOOL in grape18 groovyc18 groovyConsole18 java2groovy18 groovysh18
do
        ln $RPM_BUILD_ROOT%{_bindir}/groovy18 \
                $RPM_BUILD_ROOT%{_bindir}/$TOOL
done

# Configuration
install -d $RPM_BUILD_ROOT%{_sysconfdir}
install -p -m644 %{SOURCE2} \
        $RPM_BUILD_ROOT%{_sysconfdir}/%{name}-starter.conf

# Desktop icon
install -d $RPM_BUILD_ROOT%{_datadir}/pixmaps
install -d $RPM_BUILD_ROOT%{_datadir}/applications
install -p -m644 src/main/groovy/ui/ConsoleIcon.png \
        $RPM_BUILD_ROOT%{_datadir}/pixmaps/groovy.png
desktop-file-install --dir $RPM_BUILD_ROOT%{_datadir}/applications \
        %{SOURCE3}

# API Documentation
install -d $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
find target -type d |xargs chmod 755
cp -rp target/html/api/. $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}

# Maven depmap
install -d $RPM_BUILD_ROOT%{_mavenpomdir}
install -p -m644 pom.xml $RPM_BUILD_ROOT/%{_mavenpomdir}/JPP-%{name}.pom
#dd_maven_depmap JPP-%{name}.pom %{name}.jar
%add_to_maven_depmap org.codehaus.groovy %{name} %{version} JPP %{name}
install -p -m644 target/groovy-all.pom $RPM_BUILD_ROOT/%{_mavenpomdir}/JPP-%{name}-all.pom
#dd_maven_depmap JPP-%{name}-all.pom %{name}-all.jar
%add_to_maven_depmap org.codehaus.groovy %{name}-all %{version} JPP %{name}-all

%files
%defattr(-,root,root,-)
%{_bindir}/*
%{_javadir}/*
%{_datadir}/pixmaps/*
%{_datadir}/applications/*
%{_mavendepmapfragdir}/*
%{_mavenpomdir}/*
%config(noreplace) %{_sysconfdir}/*
%doc LICENSE.txt NOTICE.txt README.md

%files javadoc
%defattr(-,root,root,-)
%{_javadocdir}/*

%post
%update_maven_depmap

%postun
%update_maven_depmap




%changelog

* Sun Jan 01 2012 gil <gil> 1.8.5-1.mga2
+ Revision: 189412
- update to 1.8.5

* Mon Nov 28 2011 gil <gil> 1.8.4-1.mga2
+ Revision: 173924
- update to 1.8.4

* Tue Nov 01 2011 gil <gil> 1.8.3-1.mga2
+ Revision: 161019
- update to 1.8.3
- fix gmaven build problems
- imported package groovy18

